]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- 1.569
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
f51bfb2f
ER
2# PLD Linux rpm macros.
3# <http://www.pld-linux.org/>
d54662bf 4
2b05614d 5# can be used by builder script to check for version
98c5c988
ER
6%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
7
e05017c1 8%epoch 0
3241033b 9%x8664 x86_64 amd64 ia32e
e483e029 10%arm armv3l armv4b armv4l armv5teb armv5tel
9c404149 11
ba1fdedc 12# kernel compiler
345d14e5 13%kgcc %{__cc}
d2e1bc22 14%kgcc_package gcc
ba1fdedc 15
46763914 16# compiler version
69bcfbf3 17%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 18%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 19
69bcfbf3 20%__rm /bin/rm --interactive=never
36eccf0d 21
33040789 22# Build system path macros.
69bcfbf3
ER
23%__autoconf autoconf %{?debug:-Wall}
24%__automake automake -a -c -f --foreign
25%__autopoint autopoint --force
26
27# add parallel build flags: -jN
a5656a95 28#
11ecb0a1
ER
29# if you want to disable parallel build do:
30# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
a5656a95 31#
11ecb0a1
ER
32%__make /usr/bin/make %{?_smp_mflags}
33%__scons /usr/bin/scons %{?_smp_mflags}
34%__waf /usr/bin/waf %{?_smp_mflags}
b8f83d42 35%__cmake /usr/bin/cmake
a5656a95
JR
36
37%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
38 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
f93109a0 39
83094b62 40%__gettextize { \
8a995cff 41 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 42 gettextize --copy --force --no-changelog; \
97589b6e 43 else \
3241033b 44 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
45 fi; \
46 if [ ! -f po/Makevars ]; then \
3241033b 47 cp -f po/Makevars{.template,}; \
8a995cff 48 fi; \
8a995cff 49}
f93109a0 50
51%__glib_gettextize glib-gettextize --copy --force
52%__gnome_doc_common gnome-doc-common --copy
fb59e475 53%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 54%__gtkdocize gtkdocize --copy
55%__intltoolize intltoolize --copy --force
c26f1b59 56%__libtoolize libtoolize --copy --force --install
33040789 57
751c2bdd
ER
58# topdir is where builder script lives,
59# fallback to old style if SPECS/SOURCES dirs were found.
60%_topdir %{expand:%%global _topdir %(
61 if [ -d SPECS -a -d SOURCES ]; then
62 # old style rpmdir: in topdir
df3151c2 63 pwd
751c2bdd
ER
64 elif [ -d ../SPECS -a -d ../SOURCES ]; then
65 # old style rpmdir: in subdir
df3151c2 66 cd ..; pwd
751c2bdd
ER
67 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
68 # if old style rpm dir exist, go with it
69 echo $HOME/rpm; \
70 elif [ -x ../builder -a ! -d ../builder ]; then
71 # relative new style rpmdir: in package dir
df3151c2 72 cd ..; pwd
751c2bdd
ER
73 elif [ -x builder -a ! -d builder ]; then
74 # relative new style rpmdir: in packages
df3151c2 75 pwd
751c2bdd
ER
76 elif [ -x packages/builder -a ! -d packages/builder ]; then
77 # relative new style rpmdir: packages dir in current dir
df3151c2 78 cd packages; pwd
751c2bdd
ER
79 else
80 # fallback to new style rpmdir
81 echo $HOME/rpm/packages
82 fi; \
83)}%_topdir
1052b4b8 84
751c2bdd
ER
85# if %{_topdir}/SPECS exists, it's old style structure
86%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
87%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
1052b4b8
ER
88
89# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
90# if they don't exist assume we are having custom topdir (which is not named as
91# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
df3151c2
ER
92# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
93%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
94%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
95%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
384e1b2b 96
81e450f7
ER
97# The number of cvs changelog entries kept when building package.
98%_buildchangelogtruncate 20
99
6a5eda77 100%dependencytracking %{nil}
3241033b 101
e5da9169
ER
102# Relations between package names that cause dependency loops
103# with legacy packages that cannot be fixed. Relations are
104# specified as
105# p>q
106# where package p has a Requires: on something that package q Provides:
107#
108# XXX Note: that there cannot be any whitespace within the string "p>q",
109# and that both p and q are package names (i.e. no version/release).
110%_dependency_whiteout %{nil}
111
810fa5c4 112#-----------------------------------------------------------------
113#
114# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
115# BuildRequires: awk
116# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 117#
118# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 119# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
120# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 121# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 122# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 123#
124# Regular expressions are supported, but to avoid some character be treated
125# as regular expression it must be escaped twice.
126
127%filter_out \
7b6f1112 128 for (i = 1; i in I; i++) { A=0; \
810fa5c4 129 for (f in F) { \
130 if (I[i] ~ "^" F[f] "$") A=1; \
131 }; \
132 if (!A) printf(I[i] FS); \
133 }
134
135%rpmcflags %(awk 'BEGIN {
136 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 137 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 138 %{filter_out}
139}')
140
141%rpmcxxflags %(awk 'BEGIN {
09a90176 142 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
143 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 144 %{filter_out}
145}')
146
98e7f050
AM
147%rpmcppflags %(awk 'BEGIN {
148 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
149 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
150 %{filter_out}
151}')
152
810fa5c4 153%rpmldflags %(awk 'BEGIN {
c05a0741 154 split("%{?optldflags}",I);
810fa5c4 155 split("%{?filterout_ld}",F)
156 %{filter_out}
157}')
158
25f52d1a 159# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
160# but, don't use it, better use gcc as linker
161%ld_rpmldflags %(awk 'BEGIN {
162 split("%{rpmldflags}",F);
163 for (f in F) {
164 s = F[f];
165 if (s ~ /^-Wl,/) {
166 s = substr(s,5);
167 gsub(/,/," ",s);
168 };
169 printf(s FS);
170 };
171}')
172
8ef644e5 173#-----------------------------------------------------------------
174#
175# Generate a command which cleans environment, leaving only the
176# most important variables.
177# If any spec requires any additional environment it should
178# redefine %_preserve_env in following manner:
179#
180# # ADDITIONAL_VAR is required because [a good reason here]
82d10503 181# %define _preserve_env ADDITIONAL_VAR
8ef644e5 182
57ba0f59 183%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
8ef644e5 184
bb597f2b
AM
185# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
186%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
0bdc88ec 187 split("%{?_preserve_env}", P);
a363d727
ER
188 for (i in P) {
189 p = P[i];
82d10503
ER
190 if (!ENVIRON[p] || d[p]) {
191 continue;
8ef644e5 192 }
82d10503
ER
193 d[p] = 1;
194 split(ENVIRON[p], V, "");
195 val = p "=";
196 for (j = 1; j in V; j++) {
197 v = V[j];
198 if (v == q)
199 v = qq;
200 else if (v == "\\"")
201 v = q2q;
202 else if (v == "\\\\")
203 v = "\\\\\\\\";
204 else
205 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
206 val = val "" v;
207 }
208 printf(val " ");
8ef644e5 209 }
210}')
211
9c404149 212#-----------------------------------------------------------------
9f4ce098 213%configure2_13 { \
9c404149
AM
214 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
215 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
216 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 217 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 218 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 219 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 220 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
221 %{?__cc:CC="%{__cc}" ; export CC ; } \
222 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 223 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 224 --host=%{_target_platform} \
9c404149
AM
225 --prefix=%{_prefix} \
226 --exec-prefix=%{_exec_prefix} \
227 --bindir=%{_bindir} \
228 --sbindir=%{_sbindir} \
229 --sysconfdir=%{_sysconfdir} \
230 --datadir=%{_datadir} \
231 --includedir=%{_includedir} \
232 --libdir=%{_libdir} \
233 --libexecdir=%{_libexecdir} \
234 --localstatedir=%{_localstatedir} \
235 --sharedstatedir=%{_sharedstatedir} \
236 --mandir=%{_mandir} \
237 --infodir=%{_infodir} \
b6c5da52 238 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 239 %{dependencytracking} \
9c404149
AM
240}
241
39b9534b
ER
242%cmake { \
243CC="%{__cc}" \
244CXX="%{__cxx}" \
245CFLAGS="%{rpmcflags}" \
246CXXFLAGS="%{rpmcxxflags}" \
12513dc1 247LDFLAGS="%{rpmldflags}" \
89f4ca1f 248%{__cmake} \
422fbc83
AM
249-DCMAKE_INSTALL_PREFIX=%{_prefix} \
250-DCMAKE_BUILD_TYPE=%{!?debug:Release}%{?debug:Debug} \
89f4ca1f
ER
251}
252
89f4ca1f
ER
253%scons { \
254%{__scons} \
5c76736d
ER
255 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
256 CFLAGS="${CFLAGS:-%rpmcflags}" \
257 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
258 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 259 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
260 %{?__cc:CC="%{__cc}"} \
261 %{?__cxx:CXX="%{__cxx}"} \
262 libsuffix=%{_lib} \
263 prefix=%{_prefix} \
39b9534b
ER
264}
265
6339d32d 266# waf. see waf.spec
6339d32d 267%waf { \
6339d32d
ER
268CC="%{__cc}" \
269CXX="%{__cxx}" \
9e244007 270CPP="%{__cpp}" \
6339d32d
ER
271CFLAGS="%{rpmcflags}" \
272CXXFLAGS="%{rpmcxxflags}" \
273%{__waf} \
6339d32d
ER
274}
275
4a6b0d54 276#----------------------------------------------------------------
9bacbb5b 277#%configure_cache 0
fe6c4bdd 278%configure_cache_file %{buildroot}.configure.cache
73f832b3 279
e84cd836 280%configure {./configure \
4a6b0d54
AF
281 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
282 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 283 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 284 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 285 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 286 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
287 %{?__cc:CC="%{__cc}"} \
288 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 289 --host=%{_target_platform} \
4a6b0d54
AF
290 --build=%{_target_platform} \
291 --prefix=%{_prefix} \
292 --exec-prefix=%{_exec_prefix} \
293 --bindir=%{_bindir} \
294 --sbindir=%{_sbindir} \
295 --sysconfdir=%{_sysconfdir} \
296 --datadir=%{_datadir} \
297 --includedir=%{_includedir} \
298 --libdir=%{_libdir} \
299 --libexecdir=%{_libexecdir} \
300 --localstatedir=%{_localstatedir} \
301 --sharedstatedir=%{_sharedstatedir} \
302 --mandir=%{_mandir} \
303 --infodir=%{_infodir} \
b6c5da52 304 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 305 %{dependencytracking} \
9bacbb5b 306 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
307}
308
611a25d5 309# Simple macros to simplify adding bconded options to configure scripts.
310# Each macro requires bcond name and accepts optional option name, if option
311# isn't specified bcond name is used as option name. Options returning
312# --with and --enable also allow third argument which will be added as value
313# ( --with-option=value or --enable-option=value ) in case or positive
314# condition, but won't be added otherwise ( nothing or just --disable-option ).
315
316# Requirements:
317# BuildRequires: rpmbuild(macros) >= 1.527
318
319# Usage example:
320# %{__enable bcond} - returns --enable-bcond iff build condition is set
321# %{__disable bcond option} - returns --enable-option iff bcond is not set
322# %{__enable_disable bcond option value} - returns --enable-option=value if
323# bcond is set, returns --disable-option otherwise
324
325# expand bconds to --enable-something and --disable-something
326%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
327%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
328%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
329
330# same as above, but condition inverted
331%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
332%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
333%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
334
335# expand bconds to --with-something and --without-something
336%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
337%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
338%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
339
340# same as above, but condition inverted
341%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
342%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
343%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
344
345#-----------------------------------------------------------------
346
b3b1397b
ER
347# overload to insert debuginfo package
348%prep \
349%if 0%{?_enable_debug_packages}\
350%{debug_package}\
351%endif\
352%%prep\
353%{nil}
354
9c404149 355# Location of autoconf macros
ef7d5e14 356%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
9c404149 357
e2804f99 358# Location of omf files
7f0f4a79 359%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 360
e987a186 361# Location of pkgconfig files
9a4e877a 362%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
363# noarch pkgconfig files
364%_npkgconfigdir /usr/share/pkgconfig
e987a186 365
486b0b5f 366# Location of desktop files
367%_desktopdir /usr/share/applications
86dff2d0 368%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 369
481463e9 370# Location of pixmaps for applnk/desktop files
e1f0a822 371%_pixmapsdir /usr/share/pixmaps
9c404149 372
481463e9 373# Location of themable icons for applnk/desktop files
b36c8e2a 374%_iconsdir /usr/share/icons
375
e987a186
JB
376# Location of fonts directories
377%_fontsdir /usr/share/fonts
378
b3282f3f 379# Location of Gtk and associated libraries documentation
fe6c4bdd 380%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 381
fc4d7771 382# Location of KDE documentation
fe6c4bdd 383%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 384
5869828c 385# unsermake script
386%__unsermake /usr/share/unsermake/unsermake
387
9c404149 388# Current date
8cf161e2 389%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 390
9c404149
AM
391# Example files, programs, scripts...
392%_examplesdir /usr/src/examples
393
c8f7e820 394# Alternative kernel type/version
261729d9 395%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 396
8377d27d 397# The directory holding Linux kernel sources
261729d9 398%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 399
c0fe61f0
ER
400# SysV-style initscripts dir
401%_initddir /etc/rc.d/init.d
402
9c404149 403# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 404%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 405
590bc1db 406# Bootstrap release macros.
407# Usage:
408# %bcond_with bootstrap
409# Release: %{bootstrap_release 1}
410#
411# Package will have release 1 if built normally,
412# and release 0.zzz.bootstrap if built with bootstrap
413%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
414
c924d9d8
ER
415# -n drm to generate kernel%{_alt_kernel}-drm dependency
416%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
417%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
418%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
8bf3719d 419
c924d9d8 420# -s post to generate Requires(post) dependency
63d9963a
ER
421%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
422%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
423%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 424
410df6e8
ER
425# Requires name = version-release
426%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 427# Requires: name = version
91d2f1eb 428%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 429# Requires: name = version (version based on querying package %2)
0d3e64c0 430%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 431
90c674d3
JR
432# Requires: name >= version
433%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
434# Requires: name >= version (version based on querying package %2)
435%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
436
c94807f3 437%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 438
439# kernel version-release handling
95125403 440%__kernel_ver %{expand:%%global __kernel_ver %( \\
acac3049 441 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
95125403
ER
442 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
443 echo ${Z:-ERROR}; \\
1a7d3518 444)}%__kernel_ver
95125403 445
c94807f3
ER
446%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
447%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
448%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
449%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 450
6262f001
ER
451# `uname -r` to be used in @release field
452%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
453
e00dd7f6 454# sgml macros
3241033b
ER
455%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
456%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
457%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
458%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
459%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
460%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 461%docbook_sgmlcat_fix() { for l in \
462'' \
463' -- default decl --' \
464'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
465' -- hacks for opensp --' \
466'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
467'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
468'' \
469; do echo $l; done >> %1 \
470}
471
eea64748
ER
472# vim - "
473
4f044018
ER
474# minimum file size needed for compressed documents.
475# just smaller files than this get larger when compressed.
a88ae20f
ER
476# some stats:
477# - 0 byte file compressed was 25 bytes .gz
478# - 39 byte file was compressed as 57
479# - with test/test.spec@man 158 byte file was compressed also 158
480%_min_compress_bytes 159
4f044018 481
9c404149
AM
482#-----------------------------------------------------------------
483# find and gzip all files in %{_mandir} and %{infodir}
484#
485# Requires: xargs, find
486#
487#%no_install_post_compress_docs 1
488%__spec_install_post_compress_docs { \
53d5af13 489%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 490 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 491 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 492 echo "Compress man pages: $i"; \
4f044018
ER
493 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
494 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
495 find $RPM_BUILD_ROOT$i -type l | while read a; do \
496 m=$(readlink $a); \
497 rm -f $a; \
498 echo .so ${m##*/} > $a; \
499 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
500 done; \
4f044018 501 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
502 fi; \
503 done; \
728ad671
JB
504 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
505 echo "Compress info pages: %{_infodir}"; \
506 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
507 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
508 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 509 fi; \
53d5af13 510}; __spec_install_post_compress_docs } }
9c404149
AM
511
512#-----------------------------------------------------------------
513# Strip executable binaries and shared object files
514#
515# Requires: find, awk, strip, cut, xargs
516#
a2ad2754
JB
517# Special macros which affect this process:
518#%no_install_post_strip 1 # disable stripping at all
519#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
520#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
521#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
522#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
523#
9c404149 524%__spec_install_post_strip {%{!?debug: \
53d5af13 525%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 526if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
527 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
528 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
529 if [ "$modulelist" ]; then \
530 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 531 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
532 echo "$modulelist" | xargs -l512 chmod u+w; \
533 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
534 echo "DONE"; \
535 fi; \
eea64748 536 fi; \
0ac49134 537 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
538 if [ -n "$filelist" ]; then \
539 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
540 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
541 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 542 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 543 if [ -n "$elfexelist" ]; then \
4d5370ac 544 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
545 chmod u+w $elfexelist; \
546 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
547 echo "DONE"; \
548 fi; \
549 if [ -n "$elfsharedlist" ]; then \
4d5370ac 550 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
551 chmod u+w $elfsharedlist; \
552 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
553 echo "DONE"; \
554 fi; \
555 if [ -n "$archiveslist" ]; then \
4d5370ac 556 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
557 chmod u+w $archiveslist; \
558 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
559 echo "DONE"; \
560 fi; \
98a06bad 561 fi; \
0ac49134
ER
562 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
563 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
564 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 565 if [ -n "$filelist_all" ]; then \
4d5370ac 566 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 567 chmod u+w $filelist_all; \
f89ccb5f 568 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 569 echo "DONE"; \
9c404149 570 fi; \
f89ccb5f 571 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 572 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 573 chmod u+w $filelist_unneeded; \
f89ccb5f 574 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 575 echo "DONE"; \
8f74418b 576 fi; \
f89ccb5f 577 if [ -n "$filelist_debug" ]; then \
4d5370ac 578 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 579 chmod u+w $filelist_debug; \
f89ccb5f 580 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 581 echo "DONE"; \
9f0d4f36 582 fi; \
53d5af13 583fi; }; __spec_install_post_strip } } }
3241033b 584
fc5d7e20 585#-----------------------------------------------------------------
586# remove all RPATH from executable binaries and shared object files
587#
588# Requires: find, awk, cut, xargs, chrpath, uname
589#
a2ad2754
JB
590# Special macros which affect this process
591#%no_install_post_chrpath 1 # disable chrpath at all
592#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
593#
fc5d7e20 594%__spec_install_post_chrpath {%{!?debug: \
53d5af13 595%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 596if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 597 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 598 if [ -n "$files" ]; then \
d5517264 599 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 600 fi; \
98a06bad 601 if [ -n "$objs" ]; then \
4d5370ac 602 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
603 echo "$objs" | \
604 while read file; do \
605 rpath= ; \
606 chmod u+w "$file"; \
5541bf26 607 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
608 case $dir in \
609 '$ORIGIN' ) \
610 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
611 else rpath="$rpath:$dir" ; fi ; \
612 continue ; \
613 ;; \
614 esac ; \
f9abaddb
AM
615 newdir=$(readlink -m "$dir"); \
616 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
617 case $dir in \
618 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
619 echo "remove-rpath: $dir in $file"; \
620 ;; \
621 * ) \
622 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
623 else rpath="$rpath:$dir" ; fi ; \
624 ;; \
625 esac ; \
626 done ; \
627 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
628 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
629 done; \
630 fi; \
53d5af13 631fi; }; __spec_install_post_chrpath } } }
3241033b 632
611a25d5 633# vim: "
634
d366d7e0
AM
635#-----------------------------------------------------------------
636# Find all shared object files with unresolved symbols. Warn
637# and terminate if any found (termination can be turned off by define).
638#%no_install_post_check_so 1
639%__spec_install_post_check_so { \
640 __spec_install_post_check_so() { \
641 fail=0; \
642 printf "Searching for shared objects with unresolved symbols..."; \
34906a2d 643 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
7df9ddfc 644 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
d366d7e0
AM
645 done ; \
646 echo " DONE"; \
14ae3117 647 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
d366d7e0
AM
648}; __spec_install_post_check_so }}
649
d72c185f 650#-----------------------------------------------------------------
ccb8ae8d 651# Find and gzip all kernel modules
652#
653# Requires: find
654#
fe6c4bdd 655#%no_install_post_compress_modules 1
ccb8ae8d 656%__spec_install_post_compress_modules { \
53d5af13 657%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 658 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 659 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
660 if [ "$q" ]; then \
661 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
662 echo "$q" | xargs -r %{__gzip} -9nf; \
663 echo "DONE"; \
664 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
665 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
666 fi; \
3241033b 667 fi; \
53d5af13 668}; __spec_install_post_compress_modules } }
9c404149 669
ef64802f
ER
670# Remove common Perl files we don't package
671%__spec_install_post_perl_clean {\
672%{!?no_install_post_perl_clean: \
673%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
674} }
675
83094b62 676#-----------------------------------------------------------------
0e4cb4dd 677# Update GConf2 schemas
83094b62 678#
679# Requires: GConf2
680#
46885239 681%gconf_schema_install() \
307ac6c9
ER
682 umask 022; \
683 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
684 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 685%{nil}
46885239 686
687%gconf_schema_uninstall() \
24336a54 688if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 689 umask 022; \
24336a54
ER
690 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
691 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 692fi; \
f93109a0 693%{nil}
694
695#-----------------------------------------------------------------
696# Update desktop MIME database
c0a4caa0 697# requires: desktop-file-utils
c3bcd10e 698%update_desktop_database() {{ \
f93109a0 699 umask 022; \
fb59e475 700 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
701};} \
702%{nil}
f93109a0 703
c3bcd10e
ER
704%update_desktop_database_post %update_desktop_database
705
706%update_desktop_database_postun() {{ \
f27cf2fd 707if [ "$1" = "0" ]; then \
c00bf95c 708 %update_desktop_database \
f27cf2fd 709fi; \
c00bf95c
MB
710};} \
711%{nil}
f93109a0 712
fb59e475 713#-----------------------------------------------------------------
714# Update shared MIME info database
715# requires: shared-mime-info
716#
c3bcd10e 717%update_mime_database() {{ \
fb59e475 718 umask 022; \
719 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
720};} \
721%{nil}
fb59e475 722
723#-----------------------------------------------------------------
724# Update icon cache
725# requires: gtk+
726#
c3bcd10e 727%update_icon_cache() {{ \
fb59e475 728 umask 022; \
072f4b80 729 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
730};} \
731%{nil}
fb59e475 732
f93109a0 733#-----------------------------------------------------------------
734# Update scrollkeeper database
735# requires: scrollkeeper
736#
737%scrollkeeper_update_post() \
f93109a0 738 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 739%{nil}
f93109a0 740
741%scrollkeeper_update_postun() \
f27cf2fd 742if [ "$1" = "0" ]; then \
f93109a0 743 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 744fi; \
f93109a0 745%{nil}
746
9c404149
AM
747#-----------------------------------------------------------------
748# post %install sequence:
749# - autodeps exceptions
750# - compress all man and info pages,
751# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 752# - compress kernel modules if any
9c404149
AM
753
754###################################################################
755# Requires/Provides automation
3e202b06 756# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 757#
2892b5df
JB
758%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
759%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
760%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
761%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
762%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 763
338726a6
JB
764#%_noautocompressdoc %{nil}
765#
8f74418b
MM
766%_missing_doc_files_terminate_build 1%{nil}
767%_unpackaged_files_terminate_build %{nil}
8781dc74 768# (X)emacs support
d77dcb61 769%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
770%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
771%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 772
02b58f60
JK
773%__php_provides %{nil}
774%__php_requires %{nil}
775%__perl_provides %{nil}
776%__perl_requires %{nil}
fa3497cd 777%__mono_provides %{nil}
778%__mono_requires %{nil}
25043cd4
AF
779
780# Perl specific macro definitions.
c94807f3
ER
781%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
782%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
783%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
784%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
785%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
786%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 787
45c00b39 788# Ruby
c94807f3
ER
789%__ruby /usr/bin/ruby
790%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
791%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
792%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
793%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
794%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
795%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
796%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 797%ruby_rdocdir /usr/share/rdoc
c94807f3 798%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
799%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
800%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 801
7ccf7643 802%php_pear_dir /usr/share/pear
7813c433 803%php_data_dir /usr/share/php
c94807f3
ER
804%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
805%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
806%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 807
0c5d1b9b 808# extract php/zend api versions
c94807f3 809%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
e0d35dd1 810%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
c94807f3
ER
811%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
812%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
813%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
814%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
815%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
816%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
c1b2705c
ER
817
818# helper macro
f952c0f3 819%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
820
821# macros for public use
822# for php extensions (php-pecl)
68b68193 823%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 824%{__php_api_requires zend_module_api} \
f952c0f3
ER
825%{__php_api_requires -v %php_major_version debug php_debug} \
826%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 827
c1b2705c
ER
828# for zend extensions
829%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 830%{__php_api_requires zend_extension_api} \
f952c0f3
ER
831%{__php_api_requires -v %php_major_version debug php_debug} \
832%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 833
934c685f
ER
834# for php pdo modules (php-pecl-PDO_*)
835%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
836
6c3b8203
ER
837# for using PHP post scripts. for PHP >= 5.0
838%php_webserver_restart \
839[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 840[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
8e2cfc36 841if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
842 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
843 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
844 %service -q php-fcgi restart \
845 fi \
846fi \
8e2cfc36
ER
847if [ -x /etc/rc.d/init.d/php-fpm ]; then \
848 %service -q php-fpm restart \
849fi \
6c3b8203
ER
850%{nil}
851
852# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
853%php4_webserver_restart \
854[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 855[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
8e2cfc36 856if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
857 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
858 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
859 %service -q php-fcgi restart \
860 fi \
861fi \
6c3b8203
ER
862%{nil}
863
578e9248 864# X.org helper macros
434ab5a2
ER
865%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
866%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
867
c94807f3
ER
868%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
869%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
870%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
871%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
872%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
611a25d5 873# vim: '
578e9248 874
434ab5a2 875%requires_xorg_xserver_extension \
97486460
AM
876%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
877%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
878%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
879%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
880%{nil}
881
882%requires_xorg_xserver_xinput \
97486460
AM
883%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
884%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
885%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
886%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
887%{nil}
888
889%requires_xorg_xserver_font \
97486460
AM
890%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
891%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
892%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
893%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
894%{nil}
895
896%requires_xorg_xserver_videodrv \
97486460
AM
897%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
898%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
899%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
900%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 901%{nil}
578e9248 902
15d7cc4a
ER
903# TCL specific macro definitions.
904# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
905%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
906%tcl_sitearch %{_libdir}/tcl%{tcl_version}
907%tcl_sitelib %{_datadir}/tcl%{tcl_version}
908
25043cd4
AF
909# Python specific macro definitions.
910# python main version
2383a9da 911%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
912
913# directories
2383a9da 914%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 915%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 916%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 917%py_incdir /usr/include/python%{py_ver}
7ccf7643 918%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 919%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 920%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
921
922# pure python modules compilation
3241033b 923%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 924
3241033b 925%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
926
927# Software written in Python language require Python with main version
e63cd81d 928%pyrequires_eq() Requires: %1
25043cd4 929
4bf34b55
AF
930# Python 3.x
931# python main version
e9f00395 932%__python3 python3
4bf34b55
AF
933%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
934
935# directories
936%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
937%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
938%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
939%py3_incdir /usr/include/python%{py3_ver}
940%py3_sitedir %{py3_libdir}/site-packages
941%py3_sitescriptdir %{py3_scriptdir}/site-packages
942%py3_dyndir %{py3_libdir}/lib-dynload
943
944# pure python modules compilation
945%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
946
947%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
948
f12c2314 949# Hardlink binary identical .pyc and .pyo files
f12c2314 950%__spec_install_post_py_hardlink {\
53d5af13 951%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
952local a b c=0 t=0; \
953if [ -d "$RPM_BUILD_ROOT" ]; then \
954 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
955 while read a; do \
956 b="${a%.pyc}.pyo"; \
957 if cmp -s "$a" "$b"; then \
958 ln -f "$a" "$b"; \
959 c=$((c + 1)); \
960 fi; \
961 t=$((t + 1)); \
962 done < __rpm_pyc; \
963 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
964 rm -f __rpm_pyc; \
965fi; \
53d5af13 966}; __spec_install_post_py_hardlink } }
f12c2314 967
9227b3f9 968# remove python sources, so that check-files won't complain
f12c2314 969%py_postclean() \
0f82e280 970for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 971 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
972done \
973%{nil}
974
4bf34b55
AF
975%py3_postclean() \
976for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
977 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
978done \
979%{nil}
980
0fc5cff8 981# depmod macro
982%depmod() { \
f6148427 983umask 022; \
0fc5cff8 984if [ -e /boot/System.map-%1 ]; then \
3241033b 985 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 986else \
3241033b
ER
987 if [ -e /boot/System.map ]; then \
988 /sbin/depmod -a -F /boot/System.map %1; \
989 else \
990 /sbin/depmod -a %1; \
991 fi \
0fc5cff8 992fi; \
993}
994
2afc6e64 995# XMMS specific macros
c94807f3
ER
996%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
997%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
998%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
999%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1000%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1001%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1002%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1003%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1004%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1005%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1006
eb41c1ce 1007%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
d1537778 1008
848c0d68 1009# user/group checking macros
1010#
1011# Usage:
1012# %userremove myuser
1013#
1014%userremove /usr/lib/rpm/user_group.sh user del
1015%groupremove /usr/lib/rpm/user_group.sh group del
1016#
1017# Usage:
1018# if %usertestrm myuser; then
1019# /usr/sbin/userdel -r myuser
1020# Note:
1021# use these macros only if you need to call userdel/groupdel with
1022# a non-standard option or take an extra action; otherwise use the
1023# %userremove/%groupremove macros
1024#
1025%usertestrm /usr/lib/rpm/user_group.sh user testrm
1026%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
1027# user group membership management macros
1028#
1029# Usage:
efbc7726 1030# %addusertogroup [-q] myuser agroup
08d9b1f6 1031#
efbc7726
ER
1032# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1033#
1034# Requirements:
1035# BuildRequires: rpmbuild(macros) >= 1.515
2b29e157
ER
1036%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1037%{nil}
72fcfcb3 1038
1039# banner support (useful in {pre,post}{,un} and triggers)
1040#
1041# Usage:
aa41c920 1042# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 1043# the banner text, the banner text
aa41c920
ER
1044# the banner text, and following line
1045#EOF
1046# You can use any form of here-document, <<'EOF' <<-EOT will do.
1047# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1048#
72fcfcb3 1049# -a - append to the banner
a8b9562a 1050# -e - send to stderr instead of stdout
628754cb 1051# -n - no show banner (overrides -t)
1052# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
1053#
1054# Tests:
1055# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1056# rpm -E 'date | %banner -e banner' > m; sh -x m
1057#
afb54f6c 1058%banner(aent:) ( \
1b334fe4 1059RPM_SCRIPTVERBOSITY=5 \
1060[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1061if [ -x /usr/bin/banner.sh ]; then \
aa41c920 1062 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 1063else \
a8b9562a 1064 CMD="cat%{-e: >&2}" \
1b334fe4 1065fi \
276a7b45
ER
1066eval $CMD %{?2:%2}%{?3: %3}) \
1067%{nil}
628754cb 1068
990bd03f 1069# useradd/groupadd macros
4c73bc69 1070# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
1071#
1072# Usage:
1073# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1074# [-g initial_group] [-G group[,...]] login
1075#
1076# -u uid. REQUIRED
1077# -g gid/group. REQUIRED
1078# -s defaults to /bin/false
1079# -d defaults to /usr/share/empty
1080# -c No default
1081# -r is accepted but ignored (it's always set)
6bd4c218 1082# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
1083# rpm specific flags
1084# -P package name. defaults to %{name}
1085#
90627280 1086%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
1087%{!-u:%{error:useradd: Required argument -u missing}} \
1088%{!-g:%{error:useradd: Required argument -g missing}} \
1089%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
1090if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1091 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1092 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1093 exit 1 \
1094 fi \
1095else \
1096 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1097 /usr/sbin/useradd \\\
b5a7d552 1098 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
1099 -u %{-u*} \\\
1100 -r \\\
1101 -d %{-d*}%{!-d:/usr/share/empty} \\\
1102 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 1103 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
1104 -g %{-g*} \\\
1105 %{-M} \\\
1106 %{-G:-G %{-G*}} \\\
1aac682a 1107 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 1108 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280 1109fi;
611a25d5 1110# vim: "
90627280 1111
90627280
ER
1112# Usage:
1113# %groupadd [-P package] [-g gid] group
1114#
1115# -g gid. REQUIRED
1116#
1117# Sample:
1118# %groupadd -P %{name}-base -g %{gid} %{name}
1119
1120%groupadd(g:P:rfo) \
9ba02ba9
ER
1121%{!-g:%{error:groupadd: Required argument -g missing}} \
1122%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 1123if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1124 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1125 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1126 exit 1 \
1127 fi \
1128else \
1129 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1130 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1131 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1132fi;
7cb77741 1133
7c50f037 1134# webapp macros
4c73bc69 1135# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1136#
1137# The config is installed/removed inside trigger, this means that you can any
1138# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1139# updated. if you don't need the config for various reason for specific
35663282
ER
1140# webserver, just remove the symlink from config directory using webapp
1141# program. the trigger will not recreate the symlink on upgrades. In other
1142# words the config is linked to webserver config directory on first install of
1143# PACKAGE or WEBSERVER.
1144#
7c50f037
ER
1145# Add package's webserver config to webserver webapps dir.
1146# Usage:
aea687a7 1147# %webapp_register [-f] WEBSERVER WEBAPP
35663282 1148#
aea687a7 1149%webapp_register(f) \
35663282 1150%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
aea687a7 1151if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
35663282
ER
1152 /usr/sbin/webapp register %1 %2\
1153fi\
694a8f2e 1154# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1155if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1156 %{expand:%service -q %%1 reload}\
35663282
ER
1157fi\
1158%{nil}
1159
1160# Remove package's config from webserver webapps dir.
35663282 1161# Usage:
531c0efc
ER
1162# %webapp_register [-f] WEBSERVER WEBAPP
1163%webapp_unregister(f) \
35663282
ER
1164%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1165# remove link if either of the packages are gone \
5d3a09a3 1166if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1167 /usr/sbin/webapp unregister %1 %2\
16897aea 1168 %{expand:%service -q %%1 reload}\
35663282
ER
1169fi \
1170%{nil}
1171
462b26fa 1172# service macro.
4c73bc69 1173# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1174#
1175# calls usual service restart on package %post, but skips the restart if
1176# administrator has disabled automatic service restarts in either global
1177# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1178#
462b26fa 1179# Usage:
7377b5ca 1180# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1181#
a0bbe604 1182# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1183# -n NOOP mode, do not actually restart service
462b26fa 1184#
7377b5ca
ER
1185# Requirements:
1186# BuildRequires: rpmbuild(macros) >= 1.268
1187# Requires: rc-scripts
1188# -n option:
1189# BuildRequires: rpmbuild(macros) >= 1.450
1190%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1191
1192
f9aa75bf
ER
1193# Java macros. based on jpackage macros.java
1194#
1195# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1196%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1197
1198# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1199%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1200
1201# Root directory for all Java VM/SDK/JRE's private things.
1202%_jvmprivdir %{_libdir}/jvm-private
1203
1204# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1205%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1206
1207# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1208%_jvmdatadir %{_datadir}/jvm
1209
1210# Root directory for all configurations parts of Java VM/SDK/JRE's
1211%_jvmsysconfdir %{_sysconfdir}/jvm
1212
1213# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1214%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1215
1216# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1217%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1218
1219# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1220%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1221
1222# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1223%_jnidir %{_libdir}/java
f9aa75bf 1224
ed644e79
JK
1225
1226# JDK selection. Set this to name of the JDK implementation to use
1227# insead of the system default
1228#%use_jdk icedtea6
1229
1230# expands to the value with right jdk for BuildRequires header
1231# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1232# The requirement will not replace current 'default' JDK
1233%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1234
1235%buildrequires_jdk BuildRequires: %required_jdk
1236
1237%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1238
e0e23dcd 1239%_javasrcdir %{_usrsrc}/java
1240
a9254650 1241%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1242%jar %{java_home}/bin/jar
ed644e79 1243%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
fe6c4bdd
ER
1244%javac %{java_home}/bin/javac
1245%javadoc %{java_home}/bin/javadoc
6aedae62 1246
fe6c4bdd 1247%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1248
1249%jpackage_script() \
3ca65b87
ER
1250install -d $RPM_BUILD_ROOT%{_bindir}\
1251cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1252#!/bin/sh\
1253#\
1254# %{name} script\
1255# JPackage Project <http://www.jpackage.org/>\
1256\
1257# Source functions library\
1258. %{_javadir}-utils/java-functions\
1259\
1260# Source system prefs\
3ca65b87 1261if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1262 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1263fi\
1264\
1265# Source user prefs\
3ca65b87
ER
1266if [ -f $HOME/.%{name}rc ]; then\
1267 . $HOME/.%{name}rc\
6aedae62
ER
1268fi\
1269\
1270# Configuration\
1271MAIN_CLASS=%1\
1272BASE_FLAGS=%2\
1273BASE_OPTIONS=%3\
3ca65b87 1274BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1275\
1276# Set parameters\
1277set_jvm\
3ca65b87
ER
1278set_classpath $BASE_JARS\
1279set_flags $BASE_FLAGS\
1280set_options $BASE_OPTIONS\
6aedae62
ER
1281\
1282# Let's start\
3ca65b87 1283run "$@"\
6aedae62
ER
1284EOF
1285
06f11871
ER
1286# jpackage 1.7
1287# Directory for maven depmaps
1288#
1289%_mavendepmapdir /etc/maven
1290%_mavendepmapfragdir /etc/maven/fragments
1291
1292#
1293# add_to_depmap adds an entry to the depmap. The arguments are:
1294#
1295# %1 the original groupid
1296# %2 the original artifact id
1297# %3 the version
1298# %4 the new groupid
1299# %5 the new artifactid
1300#
1301
1302%add_to_maven_depmap() \
1303install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1304cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1305<dependency>\
1306 <maven>\
1307 <groupId>%1</groupId>\
1308 <artifactId>%2</artifactId>\
1309 <version>%3</version>\
1310 </maven>\
1311 <jpp>\
1312 <groupId>%4</groupId>\
1313 <artifactId>%5</artifactId>\
1314 <version>%3</version>\
1315 </jpp>\
1316</dependency>\
1317\
1318EOF\
1319%{nil}
1320
1321#==============================================================================
1322#
1323# update_maven_depmap updates the main maven depmap
1324#
1325%update_maven_depmap() \
1326echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1327if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1328cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1329fi\
1330echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1331
02c5f99a 1332# JAVA macros specific for PLD
1333
1334# Directory for tomcat context configuration files
1335%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
06f11871 1336
89c2423f 1337# Tomcat cache path
1338%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1339
1340# Clear tomcat cache
1341# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1342#
1343# Usage:
1344# %%tomcat_clear_cache appname
1345#
e09b1b1b 1346# Call this script in %postun scriptlet. It will remove compiled jsps related to
89c2423f 1347# given app.
1348#
1349%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1350
59d3ebe9 1351# PEAR install macros
4c73bc69 1352# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1353#
1354# Usage:
f7ecf326 1355# %%pear_package_setup ...
dfce8b19 1356#
59d3ebe9 1357# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1358# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1359# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1360# -D - pass -D to %setup (so the build dir is not removed)
1361# -c - register channel from local channel.xml file
11a40e7b 1362# -d - pass -d arg to pearcmd
dfce8b19
ER
1363#
1364# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1365# destination hierarchy. you should copy the tree to buildroot after
1366# patching/reorganizing with %%pear_package_install.
1367#
1368# additionally BUILDROOT is stripped from files and files are converted to UNIX
1369# line endings.
1370#
1371# the pear install process output is recorded to install.log, you should put it
8763f51e 1372# to %%doc for later debug or just for information.
dfce8b19
ER
1373#
1374# additionally additional-packages.txt is produced if it was detected that the
1375# package has optional dependencies. the file format is suitable of displaying
1376# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1377# automatically added for this file.
59d3ebe9
ER
1378
1379
1380# records install.log and transforms PEAR names to PLD Linux rpm package names.
1381%__pear_install_log \
1382tee install.log \
1383# make post message of optional packages \
5ad4663a 1384grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1385if [ -s optional-packages.txt ]; then \
1386 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1387else \
1388 rm -f optional-packages.txt \
1389fi \
1390%{nil}
1391
1392# command invoking pear cli
1393%__pear /usr/bin/pear
1394
11a40e7b 1395%pear_install(a:d:n:zD) \
59d3ebe9 1396%__pear \\\
f7ecf326 1397 -c %{builddir}/pearrc \\\
dfce8b19 1398 -d doc_dir=/docs \\\
f7ecf326
ER
1399 -d temp_dir=/tmp \\\
1400 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1401 -d bin_dir=%{_bindir} \\\
1402 -d data_dir=%{php_pear_dir}/data \\\
1403 -d test_dir=%{php_pear_dir}/tests \\\
11a40e7b 1404 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
dfce8b19 1405 install \\\
59d3ebe9 1406 --packagingroot=%{builddir} \\\
dfce8b19
ER
1407 --offline \\\
1408 --nodeps \\\
1409 %{-f:--force} \\\
67a089ff 1410 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1411 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1412%{nil}
1413
1414# The main macro.
1415# using this macro will append optional-packages.txt to the nocompressdoc list
1416# as it's displayed to user after package install. and adding additional gzip
1417# dep is just waste ;)
11a40e7b 1418%pear_package_setup(a:d:n:zDc:) \
67a089ff
ER
1419%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1420%define builddir %{_builddir}/%{srcdir} \
1421%setup -q -c -T %{-D:-D} -n %{srcdir} \
1422%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1423%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1424%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1425%pear_install \
59d3ebe9
ER
1426%{-z:cd ..} \
1427cat %{-z:$_N/}.install.log | %__pear_install_log \
1428\
dfce8b19 1429# undos sources \
2a80e4cf 1430find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1431%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1432%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1433%{nil}
1434
7bef60e8 1435# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1436# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1437%pear_package_install() \
1438cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1439find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1440# help the developer out a little: \
1441if [ -f _noautoreq ]; then \
1442 echo "AutoReqdep detected:" \
1443 echo "_noautoreq $(cat _noautoreq)" \
1444fi \
1445%{nil}
1446
0d5dd00c
ER
1447
1448# Register OpenLDAP schema.
4c73bc69 1449# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1450#
1451# Usage:
1452# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1453#
1454# -d specify dependant schemas, separated by comma
1455#
1456%openldap_schema_register(d:) \
1457for schema in %*; do \
1458 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1459 %{__sed} -i -e " \
1460 /^include.*local.schema/{ \
1461 iinclude\\t $schema\
1462 } \
1463 " /etc/openldap/slapd.conf \
1464 fi \
1465done \
1466# enable dependant schemas \
1467if [ "%{-d*}" ]; then \
1468 %{__sed} -i -e ' \
1469 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1470 s/^#// \
1471 }' /etc/openldap/slapd.conf \
1472fi \
1473%{nil}
1474
1475# Unregister OpenLDAP schema.
4c73bc69 1476# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1477#
1478# Usage:
1479# %%openldap_schema_unregister %{schemadir}/horde.schema
1480#
1481%openldap_schema_unregister() \
1482for schema in %*; do \
1483 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1484 %{__sed} -i -e " \
1485 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1486 # for symmetry it would be nice if we disable enabled schemas in post, \
1487 # but we really can not do that, it would break something else. \
1488 " /etc/openldap/slapd.conf \
1489 fi \
1490done \
1491%{nil}
1492
b0bc2936 1493%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1494
dcc6baf7 1495
1496# Build modules for kernels 2.6
1497# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1498#
1499# Usage:
aa559e46 1500# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1501#
1502# remember that proper Makefile is still required
1503# Options:
990bd03f 1504# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1505# without .ko extension, may be placed in subdirectory
aa559e46 1506# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1507# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1508# -c -- do not execute make clean
dcc6baf7 1509# <additional arguments> -- all additional arguments will be passed to
1510# make modules
1511#
1512# Additional patching supported via here document. Try:
1513# %build_kernel_modules -m module <<'EOF'
1514# your patch script here
1515# EOF
1516# Don't use it unless patching depends on config options.
1517
1518# Developer note: don't touch it unless you know how to handle '\'.
1519# - \ in script expands to nothing
1520# - \\\ in script expands to \
566398b4 1521# - \\\ inside definition expands to nothing
dcc6baf7 1522# - \\\\\\\ inside definition expands to \
1523# - in last line \ has to touch arguments so arguments passing
1524# in new lines (using \) will be supported
1525
5a81d83e 1526%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1527%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1528 \
1529%define Opts \\\\\\\
1530%if "%{_target_base_arch}" != "%{_arch}" \\\
1531 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1532 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1533 %else \\\
1534 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1535 %endif \\\
1536%else \\\
88608ef7 1537 CC="%{kgcc}" \\\
dcc6baf7 1538%endif \
88608ef7 1539%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1540 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1541 \
e364bc26 1542%{?-C:cd %{-C*}} \
dcc6baf7 1543compile() { \
ba9de9b2
ER
1544 local L="<" PATCH_SH; \
1545 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1546 set -e -x \
730239f9 1547 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1548 \
730239f9 1549for cfg in ${cfgs:-dist}; do \
dcc6baf7 1550 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1551 \
c546f6fb 1552 rm -rf o \
ec8cb195 1553 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
dcc6baf7 1554 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1555 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
ec8cb195
AM
1556 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1557 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
a2a36b0c 1558 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
ec8cb195
AM
1559 else \
1560 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1561 fi \
dcc6baf7 1562 \
1563 set +x \
1564 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1565 set -x \
1566 \
c768535c 1567 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1568 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1569 %{-p*} %{-P*} \\\
1570 %{MakeOpts} \
1571 %else \
1572 install -d o/include/config \
1573 touch o/include/config/MARKER \
588f1b0b 1574 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1575 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1576 %endif \
1577 \
5a81d83e 1578 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1579 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1580 ${1+"$@"} \\\
5a81d83e 1581 M=$PWD %{MakeOpts}} \
f635907b 1582 \
dcc6baf7 1583 %{__make} -C %{_kernelsrcdir} modules \\\
1584 ${1+"$@"} \\\
1585 M=$PWD %{MakeOpts} \
1586 \
1587 for MODULE in {%{-m*},}; do \
1588 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1589 done \
1590done \
aa559e46 1591%{?-C:cd -} \
dcc6baf7 1592} \
1593compile %{*}\
1594%{nil}
1595
1596
1597# Install kernel modules built by %build_kernel_modules
1598# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1599#
1600# Usage:
1601# %install_kernel_modules -m <modules> -d <directory>
1602#
1603# Options:
990bd03f 1604# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1605# without .ko extension, may be placed in subdirectory
1606# -d <directory> (required) -- in what subdirectory modules should be
1607# installed (eg. misc, kernel/drivers/net)
1608# -s <suffix> -- suffix to use when installing modules, useful when module
1609# with same name exists in kernel already
1610# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1611# for defining aliases, only useful with -s
dcc6baf7 1612
1613%install_kernel_modules(m:d:s:n:) \
1614%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1615%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1616%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1617 \
1618%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1619%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1620 \
b279feda 1621__install_kernel_modules() { \
730239f9 1622local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1623 \
1624for MODULE in {%{-m*},}; do \
1625 [ -n "${MODULE}" ] || continue \
730239f9
ER
1626 for cfg in ${cfgs:-dist}; do \
1627 [ "$cfg" = smp ] && suf=smp || suf= \
1628 MNAME=${MODULE##*/} \
1629 install -D ${MODULE}-$cfg.ko \\\
1630 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1631 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1632 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1633 >> %{ModprobeD}$suf/%{-n*}.conf} \
1634 done \
dcc6baf7 1635done \
b279feda 1636} \
1637__install_kernel_modules \
dcc6baf7 1638%{nil}
1639
fa65356c 1640# patchset macros
4c73bc69 1641# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1642#
1643# Usage:
1644# %patchset_source -f <seq(1) format> <start> [<end>]
1645# %patchset_patch <start> [<end>]
1646#
1647# If <end> is omited, it is assumed to be <start>.
1648#
1649# For example in preamble:
1650# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1651# and in %prep:
1652# %patchset_patch 33 44
1653
1654# generate SourceX urls from range START STOP
1655# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1656# The sources start from 10000
e91610db 1657%patchset_source(f:b:) %(
44f733ef 1658 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1659 start=$(expr $base + %1);
1660 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1661 # we need to call seq twice as it doesn't allow two formats
1662 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1663 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1664 paste %{tmpdir}/__ps{1,2};
1665 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1666) \
1667%{nil}
fa65356c
ER
1668
1669# apply sources from %patchset_source
1670# -p specify -pX for %patch line
1671# -b base offset: defaults to 10000
1672%patchset_patch(f:p:b:) %(
44f733ef 1673 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1674 start=$(expr $base + %1);
1675 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1676 echo ": patchset_patch %1%{?2: to %2}";
1677 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1678) \
1679%{nil}
fa65356c 1680
5730b44b 1681# browser plugins v2
4c73bc69 1682# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1683#
1684# Usage:
1685# %browser_plugins_add_browser <name> -p <plugindir>
1686#
1687# <name> (required) -- name of the browser. usually %{name}.
1688# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1689# -b -- default blacklists
1690# -a <arch> override arch
5730b44b
ER
1691#
1692# Example:
1693# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1694
1695%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1696%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1697%update_browser_plugins /usr/sbin/update-browser-plugins || :
1698
02ebf70f 1699%browser_plugins_add_browser(p:b:a:) \
9efd458e 1700 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1701 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1702 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1703 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1704 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1705 %{-b:cat >> $blacklist_file %{-b*}} \
1706%{nil}
1707
ad17b654
ER
1708# Helper for LUA.
1709# split string separated by space into quoted list
1710#
4c73bc69 1711# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1712#
1713# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1714%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1715
1716# adjust /etc/shells by adding and removing shells from there
4c73bc69 1717# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1718#
1719# Usage:
d9b789d9
ER
1720# %post -p <lua>
1721# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1722#
d9b789d9
ER
1723# %preun -p <lua>
1724# if arg[2] == 0 then
1725# %lua_remove_etc_shells /bin/bash /bin/rbash
1726# end
7377b5ca
ER
1727#
1728# Requirements:
d9b789d9
ER
1729# BuildRequires: rpmbuild(macros) >= 1.462
1730#
ad17b654 1731
d9b789d9 1732%lua_add_etc_shells() \
ad17b654
ER
1733t = {}\
1734f = io.open("/etc/shells", "r")\
1735if f then\
1736 for l in f:lines() do t[l]=l; end\
1737 f:close()\
1738end\
1739for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1740 if not t[s] then\
b8c0bc18 1741 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1742 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1743 end\
1744end\
1745%{nil}
1746
d9b789d9
ER
1747%lua_remove_etc_shells() \
1748t = {}\
1749f = io.open("/etc/shells", "r")\
1750if f then\
1751 for l in f:lines() do t[l]=l; end\
1752 f:close()\
1753end\
1754for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1755 print("Removing "..l.." from /etc/shells")\
1756 t[l] = nil\
1757end\
1758s=""\
1759for _, l in pairs(t) do\
1760 s=s..l.."\\n"\
1761end\
1762io.open("/etc/shells", "w"):write(s)\
1763%{nil}
1764
1765# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1766#
1767# Author: Elan Ruusamäe <glen@pld-linux.org>
1768#
1769# Usage:
1770# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1771# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1772#
1773# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1774#
1775# Requirements:
1776# BuildRequires: rpmbuild(macros) >= 1.429
1777#
1778%add_etc_shells(p) %{-p:<lua>}\
1779%{expand:%%lua_add_etc_shells %*}\
1780%{nil}
1781
ad17b654 1782%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1783%{-p:if arg[2] == 0 then}\
d9b789d9 1784%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1785%{-p:end} \
ad17b654
ER
1786%{nil}
1787
75bd6249
ER
1788# Check syntax for Python files
1789#
1790# Author: Elan Ruusamäe <glen@pld-linux.org>
1791# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1792#
1793# Usage:
1794# %py_lint src
1795#
1796# Requirements:
1797# BuildRequires: python
1798# BuildRequires: rpmbuild(macros) >= 1.469
1799
1800%py_lint() \
1801__py_lint() { \
1802find "$@" -type f -name '*.py' | python -c ' \
1803import sys \
1804import compiler \
1805\
1806err = 0\
1807for f in sys.stdin: \
1808 fd = open(f.strip()) \
1809 c = fd.read() \
1810 fd.close() \
1811 try: \
1812 compiler.parse(c) \
1813 except SyntaxError, e: \
1814 print "py_lint: %s: %s" % (f.strip(), e) \
1815 err = err + 1\
1816\
1817if err: \
1818 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1819 sys.exit(1) \
1820else: \
1821 print >> sys.stderr, "py_lint: Found no syntax errors." \
1822' \
1823}; __py_lint %* \
1824%{nil}
1825
f602e4a0 1826# Undos files
1827#
1828# Author: Paweł Zuzelski <pawelz@pld-linux.org>
0217c63b 1829# Author: Elan Ruusamäe <glen@pld-linux.org>
f602e4a0 1830#
1831# Usage:
1832# %undos list_of_files
0217c63b
ER
1833# %undos -f EXT[,EXT]
1834# %undos -i -f EXT[,EXT]
1835#
1836# -f EXT[,EXT] - find(1) files by extensions
1837# -i - case insensitive file search
1838#
1839# Example:
1840# Un-DOS all *.js, *.css files
1841# %undos -f js,css
1842# Un-DOS all *.js, *.JS files
1843# %undos -f js -i
1844# undos all Makefiles
1845# %{__find} -name Makefile | xargs %undos
f602e4a0 1846#
1847# Requirements:
1848# BuildRequires: sed >= 4.0
81a64c94 1849# BuildRequires: rpmbuild(macros) >= 1.565
f602e4a0 1850
0217c63b 1851# NB: make sure this macro stays on one line
81a64c94
ER
1852# NB: make sure it includes newline escape
1853%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1854%{nil}
f602e4a0 1855
2f79ae5a
ER
1856# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1857#
1858# Author: Elan Ruusamäe <glen@pld-linux.org>
1859#
1860# Usage:
1861# -a NAME -- add command named NAME
1862# -d NAME -- remove command named NAME
1863# -f FILE -- specify plugin configuration FILE to extract command definition from
1864#
1865# Sample:
1866# %triggerin -- nagios-nrpe
1867# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1868#
1869# %triggerun -- nagios-nrpe
1870# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1871#
1872# Requirements:
f236a3c2 1873# Requires: grep
1874# Requires: sed >= 4.0
d7cee36f 1875# BuildRequires: rpmbuild(macros) >= 1.552
2f79ae5a 1876%nagios_nrpe(a:d:c:f:) {\
d7cee36f 1877 m=$(md5sum < /etc/nagios/nrpe.cfg); \
2f79ae5a 1878 %{-a:# on -a and config exists \
d7cee36f
ER
1879 if [ -f /etc/nagios/nrpe.cfg ]; then \
1880 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1881 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
2f79ae5a
ER
1882 fi; \
1883 fi;} \
1884 %{-d:# on package remove, -d and config exists \
d7cee36f
ER
1885 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1886 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
2f79ae5a 1887 fi;} \
d7cee36f
ER
1888 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1889 %service -q nrpe restart; \
1890 fi; \
2f79ae5a
ER
1891}%{nil}
1892
070aa9f4
ER
1893# Import or update Cacti template.
1894#
1895# Author: Elan Ruusamäe <glen@pld-linux.org>
1896#
1897# Usage:
1898# %cacti_import_template XMLFILE
1899# XMLFILE -- XML template to import
1900#
1901# Sample:
1902# %post
1903# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1904#
1905# Requires: cacti >= 0.8.7e-8
1906# BuildRequires: rpmbuild(macros) >= 1.554
1907
1908%cacti_import_template() {\
1909/usr/share/cacti/cli/import_template.php --filename=%1 || :; \
1910}%{nil}
1911
cdb82983
JK
1912# pre/post script for -upstart subpackages
1913#
1914# Author: Jacek Konieczny <jajcus@jajcus.net>
1915#
1916# Usage:
1917# %upstart_post service_name
1918# %upstart_postun service_name
1919#
1920# Sample:
1921# %post upstart
1922# %upstart_post %{name}
1923#
1924# %postun upstart
1925# %upstart_postun %{name}
1926#
1927# Requirements:
1928# BuildRequires: rpmbuild(macros) >= 1.560
1929# Requires: rc-scripts >= 0.4.3
1930
1931# migrate from init script to upstart job
c4c1a53f 1932%upstart_post() \
cdb82983
JK
1933 if [ -f /var/lock/subsys/"%1" ] ; then \
1934 /sbin/service --no-upstart "%1" stop \
1935 /sbin/service "%1" start \
1936 fi
1937
1938# restart the job after upgrade or migrate to init script on removal
1939# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
1940# at this point
c4c1a53f 1941%upstart_postun() \
cdb82983
JK
1942 if [ -x /sbin/initctl ] && /sbin/initctl status "%1" 2>/dev/null | grep -q 'running' ; then \
1943 /sbin/initctl stop "%1" >/dev/null 2>&1 \
1944 [ -f "/etc/rc.d/init.d/%1" -o -f "/etc/init/%1.conf" ] && { echo -n "Re-" ; /sbin/service "%1" start ; } ; \
1945 fi
1946
f51bfb2f 1947# vim:ts=4 sw=4 noet ft=spec
This page took 0.904335 seconds and 4 git commands to generate.